/* Yahtzee for Konfabulator
	 Code by: Markus Zeller
	 Design by: Bjrn Lensig
*/

// constants for the singles
var ones=0;
var twos=1;
var threes=2;
var fours=3;
var fives=4;
var sixes=5;
var sumsingles=6;

// constants for the kinds
var threekind=7;
var fourkind=8;
var fullhouse=9;
var shortrun=10;
var longrun=11;
var yahtzee=12;
var chance=13;

// constants for the score sums
var bonus=14;
var total=15;

var scoreLength=total;
var scores=new Array(scoreLength);
var rollCount=0;

var isRolling=0;
var isPlaying=0;
var isSumSingles=0;
var fieldsLeft=0;
var matches=0;

var hold=new Array(4);
var cubevalue=new Array(4);

var cubes=new Array();
GenerateCubes();

// init the point table for user selection
var scoreFields=new Array(scoreLength);

function PositionTextField(i,x,y)
{
  // set the position for the point field
  scoreFields[i].hOffset=x;
  scoreFields[i].vOffset=y;
}

function GeneratePointTable()
{
  // generate the table where user can select points from
  for(i=0;i<scoreLength+1;i++)
  {
    obj=(scoreFields[i]);
    if(!obj) {
      obj=new Text();
    }
    obj.style="bold";
    obj.alignment="left";
    obj.size="14";
    obj.font="Arial";
    if(i!=sumsingles && i!=total && i!=bonus)
    {
      obj.data="";
      obj.onMouseEnter="scoreFields["+i+"].color='#FF0000'";
      obj.onMouseExit="scoreFields["+i+"].color='#0000FF'";
      obj.onMouseDown="handleScoreClick("+i+")";
      obj.color="#0000FF";
    } else
    {
      obj.data=0;
      obj.color="#008800";
    }
    scoreFields[i]=obj;
    delete obj;
  }
  for(i=0;i<7;i++)
  {
    PositionTextField(i,132,98+i*18.1);
  }
  for(i=0;i<7;i++)
  {
    PositionTextField(i+7,332,98+i*18.5);
  }
  for(i=0;i<2;i++)
  {
    PositionTextField(i+14,332,234+i*18.5);
  }
}

function ClearPointTable()
{
  // clear the table where points are selected from by user
  for(i=0;i<scoreLength;i++)
  {
    if(i!=sumsingles && i!=total && i!=bonus)
    {
      if(scores[i]==0) { scoreFields[i].data=""; }
      if(scores[i]==-1) { scoreFields[i].data=0; }
    }
  }
}

function MakeCube(col,count,hOffs,vOffs,width,height)
{
  // load the cube graphics for the points
	var i=(col*6)+count-1;
  cubes[i]=new Image();
	cubes[i].src="Resources/count_"+count+".png";
	cubes[i].hOffset=hOffs+(col*60);
	cubes[i].vOffset=vOffs;
  cubes[i].width=width;
  cubes[i].height=height;
  cubes[i].opacity=0;
}

function GenerateCubes()
{
  // init the cubes with all its points
  for(col=0;col<5;col++)
  {
    MakeCube(col,1,88,323,27,40);
    MakeCube(col,2,88,319,33,44);
    MakeCube(col,3,88,318,34,41);
    MakeCube(col,4,86,316,33,48);
    MakeCube(col,5,86,317,32,48);
    MakeCube(col,6,87,317,34,47);
  }
}

function doClearCubes()
{
  // make all the points invisible
  for(col=0;col<5;col++)
  {
    if(hold[col]==0)
    {
      for(i=0;i<6;i++)
      {
        cubes[col*6+i].opacity=0;
      }
    }
  }
}

function doNewGame()
{
  // init values for a new game
  if(isPlaying)
  {
    if(alert("Game is already running.","Continue game","Start new game")==2)
    {
      isPlaying=0;
      doNewGame();
    }
  } else
  {
    GeneratePointTable();
    fieldsLeft=12;
    isSumSingles=0;
    isPlaying=1;
    for(i=0;i<scoreLength;i++)
    {
      scores[i]=0;
    }
    rollCount=0;
    ClearPointTable();
    doRoll();
  }
}

function doRoll()
{
  // user hit the roll button
  if(isPlaying) {
    if(rollCount==0)
    {
      for(i=0;i<5;i++)
      {
        hold[i]=0;
        var obj=eval("cube_"+(i+1));
        obj.opacity=255;
      }
    }
    // how many rolls are left
    var holdCount=0;
    for(i=0;i<5;i++)
    {
      holdCount+=hold[i];
    }
    if(holdCount<5)
    {
      rollCount++;
      isRolling=1;
      setRollsLeft(rollCount);
      var rc;
      setStatus("Click the cubes to hold or release. Afterwards hit ROLL.");
      if(rollCount>3)
      {
        isRolling=0;
        setStatus("Select score");
      } else
      {
        doClearCubes();
        doShuffle();
      }
      doAnalyzeShuffle();
    } else
    {
      setStatus("Select score or release a cube to ROLL.");
    }
  } else
  {
  doNewGame();
  }
}

function doAnalyzeShuffle()
{
  // counting cube scores for single points
  matches=0;
  var score=0;
  var count1=0;
  var count2=0;
  var count3=0;
  var count4=0;
  var count5=0;
  var count6=0;
  for(i=0;i<5;i++)
  {
    v=cubevalue[i];
    score+=v;
    if(v==1) { count1++; }
    else if(v==2) { count2++; }
    else if(v==3) { count3++; }
    else if(v==4) { count4++; }
    else if(v==5) { count5++; }
    else if(v==6) { count6++; }
  }

  // display scores in table to be selected by user
  ClearPointTable();

  // single points
  if(count1) { if(scores[ones]==0) { scoreFields[ones].data=1*count1; matches++; } }
  if(count2) { if(scores[twos]==0) { scoreFields[twos].data=2*count2; matches++; } }
  if(count3) { if(scores[threes]==0) { scoreFields[threes].data=3*count3; matches++; } }
  if(count4) { if(scores[fours]==0) { scoreFields[fours].data=4*count4; matches++; } }
  if(count5) { if(scores[fives]==0) { scoreFields[fives].data=5*count5; matches++; } }
  if(count6) { if(scores[sixes]==0) { scoreFields[sixes].data=6*count6; matches++; } }

  // three kind + four kind
  if(count1>=3 || count2>=3 || count3>=3 || count4>=3 || count5>=3 || count6>=3) { if(scores[threekind]==0) { scoreFields[threekind].data=score; matches++; } }
  if(count1>=4 || count2>=4 || count3>=4 || count4>=4 || count5>=4 || count6>=4) { if(scores[fourkind]==0) { scoreFields[fourkind].data=score; matches++; } }

  // full house
  var pair2=0;
  var pair3=0;
  if(count1==2 || count2==2 || count3==2 || count4==2 || count5==2 || count6==2) { pair2=1; }
  if(count1==3 || count2==3 || count3==3 || count4==3 || count5==3 || count6==3) { pair3=1; }
  if(pair2 && pair3) { if(scores[fullhouse]==0) { scoreFields[fullhouse].data=25; matches++; } }

  // long run
  if(count1 && count2 && count3 && count4 && count5) { if(scores[longrun]==0) { scoreFields[longrun].data=40; matches++; } }
  if(count2 && count3 && count4 && count5 && count6) { if(scores[longrun]==0) { scoreFields[longrun].data=40; matches++; } }

  // short run
  if(count1 && count2 && count3 && count4) { if(scores[shortrun]==0) { scoreFields[shortrun].data=30; matches++; } }
  if(count2 && count3 && count4 && count5) { if(scores[shortrun]==0) { scoreFields[shortrun].data=30; matches++; } }
  if(count3 && count4 && count5 && count6) { if(scores[shortrun]==0) { scoreFields[shortrun].data=30; matches++; } }

  // yahtzee
  if(count1==5 || count2==5 || count3==5 || count4==5 || count5==5 || count6==5)
  {
    if(scores[yahtzee]==0)
    {
      scoreFields[yahtzee].data=50; matches++;
    }
    scoreFields[bonus].data=parseInt(scoreFields[bonus].data)+100;
  }

  //chance
  if(scores[chance]==0) { scoreFields[chance].data=score; matches++; }

  // no matches, then zero all left possible points
  if(!matches)
  {
    if(scores[ones]==0) { scoreFields[ones].data="kill"; }
    if(scores[twos]==0) { scoreFields[twos].data="kill"; }
    if(scores[threes]==0) { scoreFields[threes].data="kill"; }
    if(scores[fours]==0) { scoreFields[fours].data="kill"; }
    if(scores[fives]==0) { scoreFields[fives].data="kill"; }
    if(scores[sixes]==0) { scoreFields[sixes].data="kill"; }
    if(scores[threekind]==0) { scoreFields[threekind].data="kill"; }
    if(scores[fourkind]==0) { scoreFields[fourkind].data="kill"; }
    if(scores[fullhouse]==0) { scoreFields[fullhouse].data="kill"; }
    if(scores[shortrun]==0) { scoreFields[shortrun].data="kill"; }
    if(scores[longrun]==0) { scoreFields[longrun].data="kill"; }
    if(scores[yahtzee]==0) { scoreFields[yahtzee].data="kill"; }
    if(scores[chance]==0) { scoreFields[chance].data="kill"; }
  }
}

function calculateSums()
{
  var sum=0;
  // sum points for the singles
  if(scores[ones]>0) { sum+=parseInt(scores[ones]); }
  if(scores[twos]>0) { sum+=parseInt(scores[twos]); }
  if(scores[threes]>0) { sum+=parseInt(scores[threes]); }
  if(scores[fours]>0) { sum+=parseInt(scores[fours]); }
  if(scores[fives]>0) { sum+=parseInt(scores[fives]); }
  if(scores[sixes]>0) { sum+=parseInt(scores[sixes]); }
  scoreFields[sumsingles].data=sum;
  // sum points for the others
  if(scores[threekind]>0) { sum+=parseInt(scores[threekind]); }
  if(scores[fourkind]>0) { sum+=parseInt(scores[fourkind]); }
  if(scores[fullhouse]>0) { sum+=parseInt(scores[fullhouse]); }
  if(scores[shortrun]>0) { sum+=parseInt(scores[shortrun]); }
  if(scores[longrun]>0) { sum+=parseInt(scores[longrun]); }
  if(scores[yahtzee]>0) { sum+=parseInt(scores[yahtzee]); }
  if(scores[chance]>0) { sum+=parseInt(scores[chance]); }
  // bonus for single points
  if(scoreFields[sumsingles].data>63)
  {
    if(isSumSingles==0)
    {
      scoreFields[bonus].data=parseInt(scoreFields[bonus].data)+35;
      isSumSingles=1;
    }
  }
  sum+=parseInt(scoreFields[bonus].data);
  scoreFields[total].data=sum;
}

function doShuffle()
{
  // shuffle the cubes by random and make the points visible
  for(i=0;i<5;i++)
  {
    if(hold[i]==0)
    {
      var v=parseInt(Math.random()*6);
      cubevalue[i]=v+1;
      cubes[i*6+v].opacity=255;
    }
  }
}

function setStatus(s)
{
  // show status line for user instruction
  status.data=s;
}

function setRollsLeft(i)
{
  // show how many rolls are left
  i=4-i;
  var s="";
  if(i>=2) { s=i+" up"; }
  else if(i==1) { s="last"; }
  rollsleft.data=s;
}

function handleScoreClick(i)
{
  // user clicked a score
  if(i<=scoreLength)
  {
    // set the value.
    var v=scoreFields[i].data;
    if(v=="kill") { v=-1; }
    scores[i]=v;
    //make it inaccessible
    scoreFields[i].onMouseEnter="";
    scoreFields[i].onMouseExit="";
    scoreFields[i].color="#000000";
    // do the next roll
    rollCount=0;
    isRolling=0;
    fieldsLeft--;
    ClearPointTable();
    calculateSums();
    if(fieldsLeft<0)
    {
      isPlaying=0;
      setStatus("Hit ROLL to play a new game.");
      alert("Game Over");
    } else
    {
      setStatus("Hit ROLL to continue.");
    }
  }
}

function handleCubeClick(cube)
{
  // user clicked on a cube
  // decide to hold or release
  if(cube>=1 && cube<=6)
  {
    if(isRolling==1)
    {
      var obj=eval("cube_"+cube);
      var c=cube-1;
      if(hold[c]==1)
      {
        hold[c]=0;
        obj.opacity=255;
      } else if(hold[c]==0)
      {
        hold[c]=1;
        obj.opacity=120;
      }
    }
  }
}
